Package org.eclipse.cdt.core.dom.ast

# Interface IBasicType

All Superinterfaces:
  `Cloneable`, `IType`

All Known Subinterfaces:
  `ICBasicType`, `ICPPBasicType`, `IGPPBasicType`

public interface IBasicType extends IType
Interface for basic types.

Restriction:
  This interface is not intended to be implemented by clients.
Restriction:
  This interface is not intended to be extended by clients.

## Nested Class Summary

Nested Classes
Modifier and Type
Interface
Description
`static enum`
`IBasicType.Kind`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`IS_COMPLEX`
`static final int`
`IS_IMAGINARY`
`static final int`
`IS_LONG`
`static final int`
`IS_LONG_LONG`
`static final int`
`IS_SHORT`
`static final int`
`IS_SIGNED`
`static final int`
`IS_UNSIGNED`
`static final int`
`t_char`
Deprecated.
Use the type-safe version getKind(), instead.
`static final int`
`t_double`
Deprecated.
Use the type-safe version getKind(), instead.
`static final int`
`t_float`
Deprecated.
Use the type-safe version getKind(), instead.
`static final int`
`t_int`
Deprecated.
Use the type-safe version getKind(), instead.
`static final int`
`t_unspecified`
Deprecated.
Use the type-safe version getKind(), instead.
`static final int`
`t_void`
Deprecated.
Use the type-safe version getKind(), instead.

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IType

`EMPTY_TYPE_ARRAY, TYPE_MATCHER`

## Method Summary

Modifier and Type
Method
Description
`IBasicType.Kind`
`getKind()`
This returns the kind of basic type you are looking at.
`int`
`getModifiers()`
This returns the combination of modifier bits for this type.
`int`
`getType()`
Deprecated.
Use the type-safe version getKind(), instead.
`IASTExpression`
`getValue()`
Deprecated.
Types don't have values.
`boolean`
`isComplex()`
Is complex number? e.g.
`boolean`
`isImaginary()`
Is imaginary number? e.g.
`boolean`
`isLong()`
`boolean`
`isLongLong()`
`boolean`
`isShort()`
`boolean`
`isSigned()`
`boolean`
`isUnsigned()`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IType

`clone, isSameType`

## Field Details

### IS_LONG

static final int IS_LONG

Since:
  5.2
See Also:
  - Constant Field Values

### IS_SHORT

static final int IS_SHORT

Since:
  5.2
See Also:
  - Constant Field Values

### IS_SIGNED

static final int IS_SIGNED

Since:
  5.2
See Also:
  - Constant Field Values

### IS_UNSIGNED

static final int IS_UNSIGNED

Since:
  5.2
See Also:
  - Constant Field Values

### IS_COMPLEX

static final int IS_COMPLEX

Since:
  5.2
See Also:
  - Constant Field Values

### IS_IMAGINARY

static final int IS_IMAGINARY

Since:
  5.2
See Also:
  - Constant Field Values

### IS_LONG_LONG

static final int IS_LONG_LONG

Since:
  5.2
See Also:
  - Constant Field Values

### t_unspecified

@Deprecated static final int t_unspecified
Deprecated.
Use the type-safe version getKind(), instead.

See Also:
  - Constant Field Values
Restriction:
  This field is not intended to be referenced by clients.

### t_void

@Deprecated static final int t_void
Deprecated.
Use the type-safe version getKind(), instead.

See Also:
  - Constant Field Values
Restriction:
  This field is not intended to be referenced by clients.

### t_char

@Deprecated static final int t_char
Deprecated.
Use the type-safe version getKind(), instead.

See Also:
  - Constant Field Values
Restriction:
  This field is not intended to be referenced by clients.

### t_int

@Deprecated static final int t_int
Deprecated.
Use the type-safe version getKind(), instead.

See Also:
  - Constant Field Values
Restriction:
  This field is not intended to be referenced by clients.

### t_float

@Deprecated static final int t_float
Deprecated.
Use the type-safe version getKind(), instead.

See Also:
  - Constant Field Values
Restriction:
  This field is not intended to be referenced by clients.

### t_double

@Deprecated static final int t_double
Deprecated.
Use the type-safe version getKind(), instead.

See Also:
  - Constant Field Values
Restriction:
  This field is not intended to be referenced by clients.

## Method Details

### getKind

IBasicType.Kind getKind()
This returns the kind of basic type you are looking at. The type is then refined by qualifiers for signed/unsigned and short/long/long long.

Since:
  5.2

### getModifiers

int getModifiers()
This returns the combination of modifier bits for this type.

Since:
  5.2

### isSigned

boolean isSigned()

### isUnsigned

boolean isUnsigned()

### isShort

boolean isShort()

### isLong

boolean isLong()

### isLongLong

boolean isLongLong()

Since:
  5.2

### isComplex

boolean isComplex()
Is complex number? e.g. _Complex t;

Returns:
  true if it is a complex number, false otherwise
Since:
  5.2

### isImaginary

boolean isImaginary()
Is imaginary number? e.g. _Imaginr

Returns:
  true if it is an imaginary number, false otherwise
Since:
  5.2

### getType

@Deprecated int getType() throws DOMException
Deprecated.
Use the type-safe version getKind(), instead.

Throws:
  `DOMException`
Restriction:
  This method is not intended to be referenced by clients.

### getValue

@Deprecated IASTExpression getValue() throws DOMException
Deprecated.
Types don't have values.

Throws:
  `DOMException`
Restriction:
  This method is not intended to be referenced by clients.